function ClearLogDialog()
{
  inherit(this, new ModalElement(getElement('clearDialogPrompt')));
  this.header = extendElement(getElement('clearDialogPromptHeader'));
  this.currentConfigPrompt = extendElement(getElement('clearDialogPromptCurrentConfig'));
  this.currentConfigLabel = extendElement(getElement('clearDialogPromptCurrentConfigLabel'));
  this.allConfig = extendElement(getElement('clearDialogPromptAllConfig'));
  this.allConfigLabel = extendElement(getElement('clearDialogPromptAllConfigLabel'));
  this.cancelButton = extendElement(getElement('clearDialogPromptCancelButton'));
  this.okButton = extendElement(getElement('clearDialogPromptOkButton'));
 
  this.init();
}

ClearLogDialog.prototype.init = function init()
{

  this.cancelButton.controller = this;
  this.cancelButton.onclick = function ()
  {
    this.controller.hide();
  }

  this.okButton.controller = this;
  this.okButton.onclick = function ()
  {
    this.controller.clearOk(this.controller);
  }
}

ClearLogDialog.prototype.promptToClearLog = function promptToClearLog(title,configLabel,controller)
{
  this.title = title;
  this.header.innerHTML = title;
  this.controller = controller;
  this.header.innerHTML = title;
  this.currentConfigLabel.innerHTML = configLabel;
  this.allConfigLabel.innerHTML = translate('MSG_CLEAR_ALL_LOGS');

  this.show();
}

ClearLogDialog.prototype.clearOk = function clearOk(controller) 
{
  this.controller = controller;
  if( this.currentConfigLabel.innerHTML == translate('MSG_CLEAR_DIAGNOSIS_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.diagnosisLog.clearAll();
    }
    else
    {
      Frontend.diagnosisLog.clear();
    }
  }
  else if ( this.currentConfigLabel.innerHTML == translate('MSG_CLEAR_ERROR_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.errorLog.clearAll();
    }
    else
    {
      Frontend.errorLog.clear();
    }
  }
  else if ( this.currentConfigLabel.innerHTML == translate('MSG_CLEAR_TEST_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.testLog.clearAll();
    }
    else
    {
      Frontend.testLog.clear();
    }
  }
  else if ( this.currentConfigLabel.innerHTML == translate('MSG_CLEAR_IML_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.imlLog.clearAll();
    }
    else
    {
      Frontend.imlLog.clear();
    }
  }
  else if ( this.currentConfigLabel.innerHTML == translate('MSG_CLEAR_SEL_LOGS') ) {
    if( this.allConfig.checked == true )
    {
      Frontend.selLog.clearAll();
    }
    else
    {
      Frontend.selLog.clear();
    }
  }

  this.controller.hide();
}
