<?php
  header('Content-type: text/html; charset=utf-8', true);
  header('Cache-control: no-cache', true);
  header('Pragma: no-cache');

  require_once 'includes/constants.php';
  require_once 'includes/aibridge.class.php';
  require_once 'includes/translations.php';

  if( $_GET['cleanup'] == 'on' )
  {
    $result = AIBridge::cleanUpProcess();
    $xmlvalue = new XMLDocument($result);
    if ($xmlvalue)
    {
      $rootvalue = $xmlvalue->document_element();
      $cleanupstate = $rootvalue->get_content('cleanup');
      if( $cleanupstate == 'passed' )
        $cleanupcompleted = true;
      else
        $cleanupcompleted = false;
    }
  }
  $stdout = AIBridge::startSystemSurvey();
  $xml = new XMLDocument($stdout);
  if ($xml)
  {
    $root = $xml->document_element();
    if ($root->tagname() == 'error')
    {
      $message = $root->get_content();
      $isRunning = false;
    }
    else
    {
      $state = $root->get_attribute('state');
      if ($state == 'busy')
      {
        if ( IS_LINUX === true ) {
          $message = translate('MSG_AI_INTERRUPT_ERROR');
        }
        else {
          $message = translate('MSG_AI_BUSY_STARUP_ERROR');
        }
        $isRunning = false;
      }
      else if ($state == 'running')
      {
        $message = translate('MSG_SCANNING_HARDWARE');
        $processID = $root->get_attribute('processID');
        $isRunning = true;
      }
    }
  }
  else
  {
    $isRunning = false;
    if (!file_exists(AI_PATH))
      $message = 'AI NOT FOUND';
    else
      $message = 'CANNOT COMMUNICATE WITH AI';
  }
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">

<head>
  <title><?=translate('MSG_HP_INSIGHT_DIAGNOSTICS');?></title>
  
  <link type="text/css" rel="stylesheet" media="all" href="css/debugger.css"></link>
  <link type="text/css" rel="stylesheet" media="all" href="css/common.css"></link>
  <link type="text/css" rel="stylesheet" media="all" href="css/startup.css"></link>
  <script type="text/javascript">
  var CONFIG = {};
  <?=(defined('CONFIG_VERIFY') && CONFIG_VERIFY === true) ? ('CONFIG.CONFIG_VERIFY = true;' . "\n") : ('CONFIG.CONFIG_VERIFY = false;' . "\n");?>
  <?=(defined('CONFIG_VERIFY_CLOSE_ON_FAIL') && CONFIG_VERIFY_CLOSE_ON_FAIL === true) ? ('CONFIG.CLOSE_ON_FAIL = true;' . "\n") : ('CONFIG.CLOSE_ON_FAIL = false;' . "\n");?>
  <?=(defined('DEBUG_MODE') && DEBUG_MODE === true) ? ('CONFIG.DEBUG_MODE = true;' . "\n") : ('CONFIG.DEBUG_MODE = false;' . "\n");?>
  <?= 'CONFIG.DEBUG_ACTIVE = false;' ?>
  </script>

  <script type="text/javascript" src="js/lib.js"></script> <!-- Custom Javascript Library -->
  <script type="text/javascript" src="js/ui/Body.js"></script>
  <script type="text/javascript" src="js/ui/Viewport.js"></script>
  <script type="text/javascript" src="js/ui/ProgressIndicator.js"></script>
  <script type="text/javascript" src="js/ui/HotCorner.js"></script>
  <script type="text/javascript" src="js/translator.js.php"></script> <!-- Global Translator -->
  <script type="text/javascript" src="js/debugger.js"></script> <!-- DEBUGGER -->
  <script type="text/javascript">
     
        function windowResize(){
            
            var mainDiv = document.getElementById("mainDiv");
            var outterContent = extendElement(getElement("outter_content"));
            var innerContent = extendElement(getElement("inner_content"));
            var copyright = extendElement(getElement("copyright"));
            var masthead = extendElement(getElement("masthead"));
            var outterPad  = outterContent.getPaddingTop()+outterContent.getPaddingBottom();
            var innerPad = innerContent.getPaddingTop() + innerContent.getPaddingBottom();
            outterContent.style.height = (mainDiv.offsetHeight - masthead.offsetHeight - outterPad)+"px";
            innerContent.style.height = ( outterContent.offsetHeight - copyright.offsetHeight 
                - outterPad - innerPad  )+"px";
            
            var componentProgressDiv = extendElement(getElement("component_progress"));
            var overallProgressDiv = extendElement(getElement("overall_progress"))
            var statusFrame = getElement("statusFrame");
            var frameHeight = innerContent.offsetHeight - overallProgressDiv.offsetHeight - innerPad;
            if( frameHeight < parseInt(componentProgressDiv.getStyle('min-height').replace(/px/,"")) ) {
                frameHeight = 150;
            }
                
            componentProgressDiv.style.height = (frameHeight)+"px";
            statusFrame.style.height = (frameHeight)+"px";   
        }
        

        function showComponentProgressTable()
        {
            removeClass(window.frame, 'hiddenFrame');
            var componentProgressDiv = document.getElementById("component_progress");
            var statusFrame = getElement("statusFrame");
            if(  componentProgressDiv.style.display == "none" || componentProgressDiv.style.display == "" ) {
                componentProgressDiv.style.display = "block";
                componentProgressDiv.style.height = statusFrame.offsetHeight+"px";
            }
            else{
                console.log(componentProgressDiv.style.display);
                componentProgressDiv.style.display = "none";
            }

            windowResize();
        }
        
            
        </script>
  <script type="text/javascript">
  function init()
  {
    
    
    var debugOpener = new HotCorner('tl');
    debugOpener.action = function ()
    {
      window.Debugger = new Debugger();
      CONFIG.DEBUG_MODE = true;
      CONFIG.DEBUG_ACTIVE = true;
      this.active = false;
    }
    window.frame = extendElement(getElement('statusFrame'));
    window.progressIndicator = new ProgressIndicator(getElement('progressIndicator'));
    window.message = extendElement(getElement('message'));
    window.message.innerHTML = <?=('\'' . $message . '\'');?>;
    extendElement(getElement('initialWait')).hide();
    <?php
    if ($isRunning)
    {
      echo ('window.processID = \'' . $processID . '\';');
      echo ('window.frame.src = \'views/idStatus.php?processID=' . $processID);
      if (defined('OVERRIDE_LANG'))
        echo ('&overrideLang=' . OVERRIDE_LANG);
      if (defined('DEBUG_MODE') && DEBUG_MODE === true)
        echo ('&debugMode=on');
      echo '\';';
    }
    ?>
    document.oncontextmenu = function ()
    {
      return CONFIG.DEBUG_ACTIVE;
    };
    window.onresize = windowResize;
    windowResize();
  }

  function showFrame()
  {
    addClass(getElement('startupProductName'), 'hidden');
    removeClass(window.frame, 'hiddenFrame');
    var leftMiddle = extendElement(getElement('leftMiddle'));
    window.frame.setHeight(leftMiddle.getHeight());
  }

  function update(percent, status)
  {
    if (percent != null)
      progressIndicator.setPercent(percent);
    message.innerHTML = status;
    setTimeout(function ()
    {
      var url = window.frame.src;
      window.frame.src = url;
    }, 500);
  }

  function finishedRunning(message, doPause)
  {
    window.message.innerHTML = message;
    window.progressIndicator.setPercent(100);
    window.doPause = doPause;
    var src = ('utils/saveSystemSurvey.php?processID=' + window.processID);
    if (CONFIG.DEBUG_MODE === true)
      src += '&debugMode=on';
    getElement('saveFrame').src = src;
  }

  function finishedSaving()
  {
    <?php
    echo ('var url = \'' . FRONTEND_DIRECTORY . 'frontend.php?');
    $parameters = array();
    if (defined('DEBUG_MODE') && DEBUG_MODE === true)
      $parameters[] = 'debugMode=on';
    if (ADVANCED_MODE)
      $parameters[] = 'advancedMode=on';
    if (defined('OVERRIDE_LANG'))
      $parameters[] = ('overrideLang=' . OVERRIDE_LANG);
    echo implode('&', $parameters);
    echo '\';';
    ?>
    if (CONFIG.CONFIG_VERIFY == false)
    {
      window.message.innerHTML = <? printf("'%s %s ...'\n", translate('MSG_STARTING'), translate('MSG_HP_INSIGHT_DIAGNOSTICS')); ?>
      window.location = url;
    }
    else
    {
      runConfigVerify();
    }
  }

  function runConfigVerify()
  {
    window.message.innerHTML = 'Running Configuration Verification ...';
    <?php
    echo ('var url = \'' . FRONTEND_DIRECTORY . 'views/configVerify.php?');
    if (DEBUG_MODE)
      $parameters[] = 'debugMode=on';
    echo implode('&', $parameters);
    echo '\';';
    ?>
    getElement('configVerifyFrame').src = url;
  }

  function configVerifyPassed()
  {
    CONFIG.CONFIG_VERIFY = false;
    finishedSaving();
  }

  function configVerifyFailed()
  {
    if (CONFIG.CLOSE_ON_FAIL == true)
    {
      exitDiags();
    }
    else
    {
      var frame = extendElement(getElement('configVerifyFrame'));
      removeClass(frame, 'hiddenFrame');
      frame.style.position = 'absolute';
      frame.conformTo(Body);
    }
  }

  function configVerifyError(errorString)
  {
    alert(errorString);
    window.opener = self;
    window.close();
  }

  function continueToDiags()
  {
    CONFIG.CONFIG_VERIFY = false;
    finishedSaving();
  }

  function exitDiags()
  {
    window.opener = self;
    window.close();
  }
  window.onload = init;
  </script>
</head>

<body>
  <div id="mainDiv">
    <div id="masthead"> <!-- START masthead -->
      <p id="masthead_right">
        <img id="hpLogo" src="images/hp_logo.gif" alt="Hewlett-Packard" />
      </p>
      <p id="productName">
        HP Insight Diagnostics
      </p>
    </div> <!-- END masthead -->
    <div id="outter_content">
      <div id="inner_content">
        <?php if ( !$isRunning )  { ?>
          <div id="exitDiags">
            <a href="#"><div value="Exit Diagnostics"  onclick="exitDiags();" >
            <?= translate('MSG_EXIT_DIAGNOSTICS');?>
            </div></a>
          </div>
          <?php if ( ( IS_LINUX === true ) && (!$cleanupcompleted)){ ?>
            <div id="cleanUp">
              <a href="./startup.php?&cleanup=on"><div value="CleanUpProcess" >
                <?= translate('MSG_CLEAN_RELOAD_DIAGNOSTICS');?>
              </div></a>
            </div>
          <?php } ?>
        <?php } ?>

        <div id="overall_progress" onclick="showComponentProgressTable();">
          <?php if ( $isRunning )  { ?>
					  <p id="progress_animation">
              <span id="progressIndicator"></span>
            </p>
            <p id="progress_detailed_msg">
              <span><?=(translate('MSG_LOADING') . ' ' . translate('MSG_HP_INSIGHT_DIAGNOSTICS') . ' ...');?>              </span>
            </p>
          <?php } ?>

          <p id="progress_overall_msg">
            <span id="message">Message</span>
          </p>

        </div> <!-- END overall_progress -->

        <div id="component_progress">
          <iframe id="statusFrame" src="utils/dummy.html" frameborder="0"></iframe>
        </div> <!-- END component_progress -->
      </div> <!-- END inner_content -->
      <div id="copyright">
        <p >
          Copyright &#169; 2002-2015 Hewlett-Packard Development Company L.P.
        </p>
      </div>
    </div> <!-- END outter_content -->
  </div>

<!-- START initialWait -->
<div id="initialWait">
  <img src="images/hourglass.gif" /><br />
  <span id="initialWaitMessage"><?=translate('MSG_PLEASE_WAIT');?></span>
</div>
<!-- END initialWait -->



<iframe id="saveFrame" class="hiddenFrame" src="utils/dummy.html" frameborder="0"></iframe>
<iframe id="configVerifyFrame" class="hiddenFrame" src="utils/dummy.html" frameborder="0"></iframe>

</body>

</html>
